package alternatore.split;

import alternatore.drivers.driverIn.DriverIn;
import alternatore.drivers.driverIn.IDriverIn;
import alternatore.drivers.driverOut.DriverOut;
import alternatore.drivers.driverOut.IDriverOut;

import util.ParmsDB;

public class Build {

    private static Logica logica;
    private static ParmsDB db; 
    
    public static void main(String [] args) {
        ParmsDB db = new ParmsDB(args);   /* -pp ... -lca ... -lcp ... -uca ... -ucp ... */
        build( );
        logica.run( );
    }

    /*
     * Costruisce il distributore Split.
     */
    private static void build( ) {
        String ProducerPort = db.getPar("pp"); /* port to listen to producer */
        IDriverIn in = new DriverIn(ProducerPort); 
        
        String LowConsumerAddress = db.getPar("lca"); /* low consumer address and port */
        String LowConsumerPort = db.getPar("lcp");
        IDriverOut outL = new DriverOut(LowConsumerAddress, LowConsumerPort); 
        
        String UpConsumerAddress = db.getPar("uca"); /* up consumer address and port */
        String UpConsumerPort = db.getPar("ucp");
        IDriverOut outU = new DriverOut(UpConsumerAddress, UpConsumerPort); 
        
        logica = new Logica(in,outL,outU);
    }
}